<?php

	class COPYDATE extends Plugin {
	
		function getContent ($value) {
		
			$start = $this->settings->get ('startyear'); 	// Jahr, in dem der erste Content erstellt wurde
			$pre = $this->settings->get ('pretext');		// Text, vor dem Datum
			$post = $this->settings->get ('posttext');		// Text, nach dem Datum

			$thisyear = date('Y'); // Aktuelles Jahr
			if ($start != '' && $thisyear > $start) $content = $start . ' - ' . $thisyear;
			else $content = $thisyear;

			$content = '&copy; ' . $content; // Copyright-Zeichen anhängen

			if ($pre != '') $content = $pre . ' ' . $content;
			if ($post != '') $content = $content . ' ' . $post;
			
			return $content;
			
		}
		
		function getConfig () {
		
			$config = array ();
			
			// Startjahr
			$config['startyear'] = array (
				'type' => 'text',
				'description' => 'Startjahr (YYYY)',
				'maxlength' => 4,
				'size' => 4,
				'regex' => '/^[0-9]{4}$/i',
				'regex_error' => 'Bitte geben Sie eine vierstellige Jahreszahl ein!'
			);

			// Text vor der Jahreszahl
			$config['pretext']  = array(
				'type' => 'text',
				'description' => 'Text vor der Datumsangabe',
				'maxlength' => '100',
				'size' => '5'
			);

			// Text nach der Jahreszahl
			$config['posttext']  = array(
				'type' => 'text',
				'description' => 'Text nach der Datumsangabe',
				'maxlength' => '100',
				'size' => '5'
			);

			return $config;
			
		}
		
		function getInfo () {
		
			$info = array (
				// Plugin-Name + Version
				'<b>COPYDATE</b> Revision: 2',
				// moziloCMS-Version
				'2.0',
				// Kurzbeschreibung nur <span> und <br /> sind erlaubt
				'Stellt das Tag {COPYDATE} zur Verfügung, das ins Template eingefügt werden kann.<br />Das Tag wird durch die aktuelle Jahreszahl im Format "YYYY" ersetzt.<br /><br />Wird in den Einstellungen ein Startjahr angegeben, wird im Platzhalter außerdem das Startjahr angegeben.',
				// Name des Autors
				'Frederik S. Held, HPdesigner (Migration zu 2.0)',
				// Download-URL
				'http://www.frederikheld.de',
				// Platzhalter für die Selectbox in der Editieransicht 
				// - ist das Array leer, erscheint das Plugin nicht in der Selectbox
				array ()
			);
			
			return $info;
			
		}
		
	}
	
?>