<?php

class PrintView extends Plugin {


// ######################################################################
    function getContent($value) {

        $values = explode(",", $value);
        global $syntax;
        global $language;
        global $specialchars;
        global $CatPage;
        global $ACTION_REQUEST;
        global $QUERY_REQUEST;
        global $CAT_REQUEST_URL;
        global $PAGE_REQUEST_URL;

        // Druckansicht erzeugen
        if (isset($_GET["printview"])) {

            // print_template.html laden
            $print_template_file = PLUGIN_DIR_REL."PrintView/printview_template.html";
            if (!$file = @fopen($print_template_file, "r"))
                die($language->getLanguageValue1("message_template_error_1", $print_template_file));
            $print_template = fread($file, filesize($print_template_file));
            fclose($file);

            // platzhalter {CONTENT} im print_template durch den aktuellen content ersetzen
            $content = $syntax->content;
            preg_match("/---content~~~(.*)~~~content---/Umsi", $content, $match);
            $content = $match[0];
            $content = str_replace("{CONTENT}", $content, $print_template);

            // und alles wieder retour
            $syntax->content = $content;
            return;

        } else {
        // Link für aktuelle Seite mit URL-Parameter für PrintView ausgeben

            // zusätzliche url parameter bei sitemap und suche extra mitgeben
            $add_url_param = "";
            if (!empty($ACTION_REQUEST)) {
                $add_url_param = "&action=".$ACTION_REQUEST;

                if (!empty($QUERY_REQUEST)) {
                    $add_url_param .= "&query=".$QUERY_REQUEST;
                }
            }

            // Link ausgeben
            $url = $CatPage->get_Href(CAT_REQUEST,PAGE_REQUEST,"printview=true".$add_url_param);
            $link_title = $specialchars->rebuildSpecialChars($this->settings->get("linkTitle"),true,true);
            $link_text  = $specialchars->rebuildSpecialChars($this->settings->get("linkText"),true,true);
            #$link_text = str_replace(" ", "&nbsp;", $link_text);
            #return '<a href="'.$url.'" target="_blank">'.$link_text.'</a>';
            return '<a href="'.$url.'" class="printview" target="_blank" title="'.$link_title.'">' . $link_text . '</a>';
        }
    }

// ######################################################################
    function getConfig() {
        $config['linkTitle']  = array(
            "type" => "text",
            "description" => "Titel für den Druckansicht-Link",
            "maxlength" => "70",
            "size" => "40",
        );
        $config['linkText']  = array(
            "type" => "text",
            "description" => "Text für den Druckansicht-Link",
            "maxlength" => "70",
            "size" => "40",
        );
        return $config;
    }


// ######################################################################
    function getInfo() {
        #global $ADMIN_CONF;
        #$language = $ADMIN_CONF->get("language");

        $info['deDE'] = array(
            // Plugin-Name
            "<b>PrintView</b> Revision: 151",
            // CMS-Version
            "2.0",
            // Kurzbeschreibung
            'Erzeugt die Druckansicht der aktuellen Seite in neuem Fenster/Tab.<br /><br />
            <span style="font-weight:bold;">Nutzung:</span><br />
            {PrintView} an der gewünschten Stelle im template.html oder der Inhaltsseite erzeugt den Link für den Aufruf
            der Druckansicht.<br /> <br />
            <span style="font-weight:bold;">Anpassung:</span><br />
            Im Plugin-Ordner sind print_template.html und print_style.css um die Druckansicht nach belieben anzupassen.<br />',
            // Name des Autors
            "hausl78, HPdesigner (Migration nach 2.0)",
            // Download-URL
            "http://mozilo.de/plugins/",
        array(
            '{PrintView}' => 'Erzeugt einen Link zur Druckansicht der aktuellen Seite.')
        );

        #if(isset($info[$language])) {
        #    return $info[$language];
        #} else {
          return $info['deDE'];
        #}
    }

}
?>