<?php if(!defined('IS_CMS')) die();

class Privacy extends Plugin {

    function getContent($value) {
        global $CatPage;
		global $CMS_CONF;
		global $specialchars;
		global $language;
		
		if (getRequestValue('privacy', 'get', false) == 1){
			 $_SESSION['privacy'] = 1;
		}
		
		if (isset( $_SESSION['privacy'])){
			return;
		}
		
		$i18nPara = "";
		if (isset($_GET["i18n"])){
			$i18nPara = "&amp;i18n=" .  getRequestValue('i18n', 'get', false);			
		}			
		
		$text = $this->settings->get("policy");
		
		$cat = $this->settings->get("cat");
		$page = $this->settings->get("page");
		
		$link = "";
		if(!$CatPage->exists_CatPage($cat,$page)) {
            $cat_text = $specialchars->rebuildSpecialChars($cat,true,true);
            $page_text = $specialchars->rebuildSpecialChars($page,true,true);
            $link =  $this->createDeadlink($language->getLanguageValue("tooltip_link_page_error_2", $page_text, $cat_text));
        }
		else{
			$linksrc = "index.php?cat=".$cat."&amp;page=".$page ."&amp;";		
			if($CMS_CONF->get("modrewrite") == "true") {
				$linksrc = URL_BASE. $cat."/".$page.".html?";          
			}
			
			$linksrc .= "privacy=1" . $i18nPara;
			$link = "<a href=\"". $linksrc . "\">" . $this->settings->get("linkname") . "</a>";
		}
        return  "<div class=\"info_warning\">" . $text . $link . "</div>";
    }
	function createDeadlink( $text) {

        return '<span class="deadlink">'.$text.'</span>';
    }
	
    function getConfig() {
        global $ADMIN_CONF;
        
        $adminlanguage = $ADMIN_CONF->get("language");

       		
		$config['deDE'] = array();
        $config['deDE']['policy']  = array(
            "type" => "textarea",
            "rows" => "10",
            "description" => "Kurzer Datenschutzhinweis  mit einem Link zu der Datenschutzhinweis-Seite. Der Link wird automatisch am Ende des Texts gebildet.",
            "regex" => "/^.+$/", // wenigstens ein Zeichen!
            "regex_error" => "Kein Text eingegeben."
        );
		$config['deDE']['cat']  = array(
            "type" => "text",
            "description" => "Kategorie in der sich die Datneschutzhinweis-Seite befindet",
            "regex" => "/^.+$/", // wenigstens ein Zeichen!
            "regex_error" => "Keine Kategorie eingegeben."
        );
		
		$config['deDE']['page']  = array(
            "type" => "text",
            "description" => "Der Name der Seite mit dem Datenschutzhinweis.",
            "regex" => "/^.+$/", // wenigstens ein Zeichen!
            "regex_error" => "Keine Seite eingegeben."
        );
		
		$config['deDE']['linkname']  = array(
            "type" => "text",
            "description" => "Name für den Link.",
            "regex" => "/^.+$/", // wenigstens ein Zeichen!
            "regex_error" => "Kein Link-Name eingegeben."
        );
		
		$config['enEN'] = array();
        $config['enEN']['policy']  = array(
            "type" => "textarea",
            "rows" => "10",
            "description" => "Short privacy policy text with link to the privacy policy page. The link is automatically created at the end of the text.",
            "regex" => "/^.+$/", // wenigstens ein Zeichen!
            "regex_error" => "No text entered."
        );
		
		$config['enEN']['cat']  = array(
            "type" => "text",
            "description" => "Category name with the privacy policy page.",
            "regex" => "/^.+$/", // wenigstens ein Zeichen!
            "regex_error" => "No category name entered."
        );
		
		$config['enEN']['page']  = array(
            "type" => "text",
            "description" => "The page name with the policy.",
            "regex" => "/^.+$/", // wenigstens ein Zeichen!
            "regex_error" => "No page name entered."
        );
		
		$config['enEN']['linkname']  = array(
            "type" => "text",
            "description" => "Link name.",
            "regex" => "/^.+$/", // wenigstens ein Zeichen!
            "regex_error" => "No link name entered."
        );
		
		
        if(isset($config[$adminlanguage])) {
            return $config[$adminlanguage];
        }
        // Stellt das Plugin diese Sprache nicht zur Verfügung, werden die englischen Optionen zurückgegeben.
        else {
            return $config['enEN'];
        }
    }

    function getInfo() {
        return array(
            // Plugin-Name
            "<b>Privacy</b> (Datenschutzhinweis) Version: 0.1",
            // Plugin-Version
            "2.0 / 2.1",
            // Kurzbeschreibung
            'Gibt einen Datenschutzhinweis aus. / Shows (link to) the privacy policy. {Privacy}',
            // Name des Autors
            "A. Fleischmann",
            // Download-URL
            array("http://www.mozilo.info","mozilo.info"),
            array("{Privacy}" => "Datenschutzhinweis/Privacy policy")
        );
    }
}

?>