<?php if(!defined('IS_CMS')) die();
 
/***************************************************************
* 
*  SlimBox2 Galerie von stefanbe
* Erzeugt die SlimBox v2.05 Galerie mit Einstellungen
*
***************************************************************/

class SlimBox2 extends Plugin {

    private $slimlang;

    function getContent($value) {

        // damit man im Bilduntertitel auch Kommas als Text angeben kann ^,
        $value = str_replace("^,", "~~savedKomma~~", $value);
        #$values = explode(",", $value);
        $values = explode(",", str_replace("~~savedKomma~~", ",", $value));

        global $specialchars;
        global $language;
        global $CMS_CONF;
        $this->slimlang = new Language($this->PLUGIN_SELF_DIR."lang_".$CMS_CONF->get("cmslanguage").".txt");
        // Übergebene Parameter überprüfen
        $gal_request = $specialchars->replacespecialchars($specialchars->getHtmlEntityDecode($values[0]),false);
        if (getRequestValue('gal','get', false))
            $gal_request = $specialchars->replacespecialchars($specialchars->getHtmlEntityDecode(getRequestValue('gal','get', false)),false);
        $dir_gallery      = BASE_DIR.GALLERIES_DIR_NAME."/".$gal_request."/";
        $dir_thumbs       = $dir_gallery.PREVIEW_DIR_NAME."/";
        $dir_gallery_url  = URL_BASE.GALLERIES_DIR_NAME."/".$gal_request."/";
        $dir_thumbs_url   = URL_BASE.GALLERIES_DIR_NAME."/".$gal_request."/".PREVIEW_DIR_NAME."/";

        global $syntax;
        $syntax->insert_jquery_in_head('jquery');
        $syntax->insert_in_head($this->SlimBoxhead());
        // wenns nur ein Bild ist
        if(isset($values[0]) and strpos($values[0],'src="') > 0) {
            if(!isset($values[1]) or (isset($values[1]) and strpos($values[1],'src="')) < 1) {
                return '<span class="deadlink">Kein bild</span>';
            }
            $slimbox_subtitle = NULL;
            if(isset($values[1]) and strpos($values[1],'imagesubtitle">') > 0) {
                $start_subtitel = strpos($values[1],'imagesubtitle">') + strlen('imagesubtitle">');
                $leng_subtitel = strpos($values[1],'</span>',$start_subtitel);
                $slimbox_subtitle = ' title="'.substr($values[1],$start_subtitel,($leng_subtitel - $start_subtitel)).'"';
            }
            $src_start = substr($values[1],(strpos($values[1],'src="') + 5));
            $src = substr($src_start,0,(strpos($src_start,'"')));
            // return SlimBox Bild Link
            return '<a href="'.$src.'" rel="lightbox"'.$slimbox_subtitle.' class="slimboxlink">'.$values[0].'</a>';
        }

        // Bilder je Zeile ermitteln
        $picsperrow = 0;
        // Wenn als zweiter Param Integer, dann ist das die picsperrow
        if (isset($values[1]) and ctype_digit($values[1]))
            $picsperrow = $values[1];
        // Wenn leer, dann aus $PluginConf auslesen
        if (empty($picsperrow))
            $picsperrow = $this->settings->get("picsperrow");
        // Wenn leer dann Fallback                
        if (empty($picsperrow))
            $picsperrow = 4;

        // "Einzelvorschau"
        $singlePreview = NULL;
        if (isset($values[1]) and strpos(strtolower($values[1]), "einzelvorschau") !== false) {
            $singlePreview = "";
            // Und wenn Doppelpunkt dann mit Wert nach : füllen
            if (strpos($values[1], ":") !== false)
                $singlePreview = substr($values[1], strpos($values[1], ":")+1 );
        }

        // Galerie gibts nicht
        if (($gal_request == "") || (!file_exists($dir_gallery))) {
            return '<span class="deadlink">'.'Unbekanntes Galerieverzeichnis "'.$specialchars->rebuildSpecialChars($gal_request, false, false).'"!'.'</span>';
        }

        // Galerie blank nur den Link für die Inhaltseite ausgeben
        if ($this->settings->get("target") == "_blank" and !isset($_GET["gal"])) {
            $link_text = $specialchars->rebuildSpecialChars($gal_request, false, false);
            if(count($values) > 1) {
                $link_text = $specialchars->rebuildSpecialChars($values[1], false, false);
            }
            $modrewrite_link = "";
            if($CMS_CONF->get("modrewrite") == "true")
                $modrewrite_link = ".html";
            return "<a class=\"gallery\" href=\"index.php".$modrewrite_link."?gal=".$gal_request."\" target=\"".$this->settings->get("target")."\">".$link_text."</a>";
        }
        $alldescriptions = false;
        // Bild Beschreibungen hohlen
        if(is_file($dir_gallery."/texte.conf.php"))
            $alldescriptions = new Properties($dir_gallery."texte.conf.php");
        // Galerieverzeichnis einlesen
        $picarray = $this->getSlimBoxPicsAsArray($dir_gallery, array("jpg", "jpeg", "jpe", "gif", "png"));
        // wenn die Galerie leer ist
        $html = 'Es wurde kein Galerieverzeichnis angegeben!';
        if (count($picarray) > 0) {
            // wenn sie nicht leer ist erstellen
            $html = $this->getSlimBoxThumbnails($picarray, $dir_thumbs_url, $dir_gallery_url, $alldescriptions, $gal_request, $picsperrow, $singlePreview, $this->settings->get("cfgTxtThumbnail"), $this->settings->get("cfgTxtSlimbox"));
        }
        // aufräumen, falls auf einer Seite 2x SlimBox aufgerufen wird.
        unset($values[1]);

        // Galerie ausgeben
        return $html;
    } // function getContent

    function SlimBoxhead() {
        $bgopacity = 0.6;
        $buttonopacity = 0.6;
        $slimbox = '<!-- slimbox2.05 -->'
             .'<script type="text/javascript" src="'.$this->PLUGIN_SELF_URL.'js/slimbox2.05.min.js"></script>'
             .'<script type="text/javascript">/* <![CDATA[ */'
             .'if (!/android|iphone|ipod|series60|symbian|windows ce|blackberry/i.test(navigator.userAgent)) {jQuery(function($) {$("a[rel^=\'lightbox\']").slimbox({'
            .'buttonsrc: "'.$this->PLUGIN_SELF_URL.'img/",'
            .'loop: false,'
            .'overlayOpacity: '.$bgopacity.','
            .'opacityButton: '.$buttonopacity.','
            .'overlayFadeDuration: 400,'
            .'initialWidth: 250,'
            .'initialHeight: 250,'
            .'resizeDuration: 400,'
            .'imageFadeDuration: 400,'
            .'captionAnimationDuration: 400,'
            .'closeText: "'.$this->slimlang->getLanguageValue('close').'",'
            .'prevText: "'.$this->slimlang->getLanguageValue('prev').'",'
            .'nextText: "'.$this->slimlang->getLanguageValue('next').'",'
            .'counterText: "'.$this->slimlang->getLanguageValue('counter').'",'
            .'closeKeys: [27, 88, 67],'
            .'previousKeys: [37, 80],'
            .'nextKeys: [39, 78]'
            .'}, null, function(el) {return (this == el) || ((this.rel.length > 8) && (this.rel == el.rel));});});}'
            .'/* ]]> */</script>'
            .'<!-- slimbox2.05 end-->';
        return $slimbox;
    }
    // ------------------------------------------------------------------------------
    // Thumbnails-HTML erzeugen
    // ------------------------------------------------------------------------------
    function getSlimBoxThumbnails($picarray, $dir_thumbs_url, $dir_gallery_url, $alldescriptions, $gal_request, $picsperrow, $singlePreview, $cfgTxtThumbnail, $cfgTxtSlimbox) {
        global $specialchars;
        global $language;

        $thumbs = "";
        if (is_null($singlePreview))
            $thumbs = '<table class="gallerytable" summary="gallery table"><tr>';

        $i = 0;
        for ($i = 0; $i < count($picarray); $i++) {
            // Bildbeschreibung, Alt-Text, Beschreibung SlimBox holen

            // $description ist der Text unter Thumbnail ($cfgTxtThumbnail kann sein "title", "filename", "nothing")
            $description = "";
            if ($cfgTxtThumbnail == "title")
                $description = $this->getSlimBoxCurrentDescription($picarray[$i],$picarray,$alldescriptions);
            if ($cfgTxtThumbnail == "filename") 
                $description = $specialchars->rebuildSpecialChars($language->getLanguageValue("alttext_image_1",$picarray[$i]),true,true);

            // $slimbox_description ist der Untertitel im slimbox-Fenster und der mouseover-Text beim Thumbnail
            // $cfgTxtSlimbox kann sein "title", "filename", "nothing"
            $slimbox_description = "";
            if ($cfgTxtSlimbox == "title")
                $slimbox_description =  $this->getSlimBoxCurrentDescription($picarray[$i],$picarray,$alldescriptions);
            if ($cfgTxtSlimbox == "filename") 
                $slimbox_description = $specialchars->rebuildSpecialChars($language->getLanguageValue("alttext_image_1",$picarray[$i]),true,true);
            if ($slimbox_description == "&nbsp;")
                $slimbox_description = "";

            // img-alt-Text ist entweder der Titel lt. Galerie oder der Dateiname
            $alttext = $description;
            if ($alttext == "&nbsp;")
                $alttext = $specialchars->rebuildSpecialChars($language->getLanguageValue("alttext_image_1",$picarray[$i]),true,true);

            // Einzelvorschau oder Normale Auflistung der Thumbs?
            if (!is_null($singlePreview)) {
                // erster Durchlauf
                if ($i == 0) {
                    if ($singlePreview == "") {
                        // erstes Galeriebild als Vorschau
                        $thumbs .= '<a href="'.$specialchars->replaceSpecialChars($dir_gallery_url.$picarray[$i],true).'" rel="lightbox-'.$gal_request.'" title="'. $slimbox_description.'" class="slimboxlink">';
                        $thumbs .= '<img src="'.$specialchars->replaceSpecialChars($dir_thumbs_url.$picarray[$i],true).'" alt="'.$alttext.'" class="thumbnail" />';
                        $thumbs .= "</a>";
                    } else { 
                        // Bild aus mozilo Syntax als Vorschau oder Textlink
                        // oder beliebiger Textlink als Vorschau
                        $thumbs .= '<a href="'.$specialchars->replaceSpecialChars($dir_gallery_url.$picarray[$i],true).'" rel="lightbox-'.$gal_request.'" title="'.$slimbox_description.'" class="slimboxlink">';
                        $thumbs .= $singlePreview;
                        $thumbs .= "</a>";
                    }
                } else { // (i==0)
                    // sonst nurmehr die <a href..> für slimbox-Fenster erzeugen
                    $thumbs .= '<a href="'.$specialchars->replaceSpecialChars($dir_gallery_url.$picarray[$i],true).'" rel="lightbox-'.$gal_request.'" title="'. $slimbox_description.'" class="slimboxlink"></a>'."\n";
                }
            } else { // !is_null($singlePreview) - normale Darstellung
                if (($i > 0) && ($i % $picsperrow == 0)) // Neue Tabellenzeile aller picsperrow Zeichen
                    $thumbs .= "</tr>\n<tr>";
                $thumbs .= '<td class="gallerytd" style="width:'.floor(100 / $picsperrow).'%;">';
                $thumbs .= '<div class="gallerytd-div"><a href="'.$specialchars->replaceSpecialChars($dir_gallery_url.$picarray[$i],true).'" rel="lightbox-'.$gal_request.'" title="'. $slimbox_description.'" class="slimboxlink">';
                $thumbs .= '<img src="'.$specialchars->replaceSpecialChars($dir_thumbs_url.$picarray[$i],true).'" alt="'.$alttext.'" class="thumbnail" />';
                $thumbs .= "</a><br />";
                if($description != "&nbsp;")
                    $thumbs .= '<div class="description">'.$description.'</div>';
                $thumbs .= "</div></td>\n";
            }
        } // for ... picarray

        if (is_null($singlePreview)) {
            while ($i % $picsperrow > 0) {
                $thumbs .= '<td class="gallerytd" style="width:'.floor(100 / $picsperrow).'%;">&nbsp;</td>'."\n";
                $i++;
            }
        $thumbs .= "</tr></table>\n";
        }

        if ($this->settings->get("target") == "_self")
            $thumbs = '<div class="embeddedgallery">' . $thumbs . '</div>';

        // Rückgabe der Thumbnails
        return $thumbs;
    }
    // ------------------------------------------------------------------------------
    // Beschreibung zum aktuellen Bild auslesen
    // ------------------------------------------------------------------------------
    function getSlimBoxCurrentDescription($picname,$picarray,$alldescriptions) {
        global $specialchars;

        if(!$alldescriptions)
            return "&nbsp;";
        // Keine Bilder im Galerieverzeichnis?
        if (count($picarray) == 0)
            return "&nbsp;";
        // Bildbeschreibung einlesen
        $description = $alldescriptions->get($picname);
        if(strlen($description) > 0) {
            return $specialchars->rebuildSpecialChars($description,false,true);
        } else {
            return "&nbsp;";
        }
    }
    // ------------------------------------------------------------------------------
    // Auslesen des übergebenen Galerieverzeichnisses, Rückgabe als Array
    // ------------------------------------------------------------------------------
    function getSlimBoxPicsAsArray($dir, $filetypes) {
        $picarray = array();
        $currentdir = opendir($dir);
        // Alle Dateien des übergebenen Verzeichnisses einlesen...
        while ($file = readdir($currentdir)){
            if(isValidDirOrFile($file) and (in_array(strtolower(substr(strrchr($file, "."), 1, strlen(strrchr($file, "."))-1)), $filetypes))) {
                // ... wenn alles passt, ans Bilder-Array anhängen
                $picarray[] = $file;
            }
        }
        closedir($currentdir);
        sort($picarray);
        return $picarray;
    }

    function getConfig() {
        global $ADMIN_CONF;
        $language = $ADMIN_CONF->get("language");
        // Rückgabe-Array initialisieren
        // Das muß auf jeden Fall geschehen!
        $config = array();
        // Nicht vergessen: Das gesamte Array zurückgeben

        $config['deDE']['picsperrow'] = array(
            "type" => "text",
            "maxlength" => "2",
            "size" => "3",
            "description" => "Vorschaubilder pro Zeile",
            "regex" => "/^[1-9][0-9]?/",
            "regex_error" => 'Zahl 1-99 erlaubt!'
        );

        $config['deDE']['cfgTxtThumbnail'] = array(
            "type" => "radio",
            "description" => "Text unter dem Vorschaubild",
            "descriptions" => array(
                "title" => "Bild-Titel wie in Galerie angegeben",
                "filename" => "Bild-Dateiname",
                "nothing" => "Nichts"
                )
            );

        $config['deDE']['cfgTxtSlimbox'] = array(
            "type" => "radio",
            "description" => "Text unter dem Bild im slimbox-Fenster",
            "descriptions" => array(
                "title" => "Bild-Titel wie in Galerie angegeben und Zähler",
                "filename" => "Bild-Dateiname und Zähler",
                "nothing" => "Kein Text, nur Zähler"
                )
            );
 
        $config['deDE']['target'] = array(
            "type" => "radio",
            "description" => "Wie soll die Galerie geöffnet werden: In einem neuen Fenster/Tab oder im aktuellen?",
            "descriptions" => array(
                "_self" => 'Aktuelles Fenster ("target self")',
                "_blank" => 'Neues Fenster ("target blank")',
                )
        );

        if(isset($config[$language])) {
            return $config[$language];
        } else {
            return $config['deDE'];
        }
    } // function getConfig    

    function getInfo() {
        global $ADMIN_CONF;
        $language = $ADMIN_CONF->get("language");

        $info['deDE'] = array(
            // Plugin-Name
            "<b>SlimBox v2.05</b> Revision: 15",
            // Plugin-Version
            "2.0",
            // Kurzbeschreibung
            'Erzeugt die SlimBox v2.05 Galerie<br />
            <SPAN style="color:red;">Funktioniert nur mit JavaScript!</SPAN><br /><br />
            Platzhalter:<br />
            <SPAN style="font-weight:bold;">{SlimBox2|Meine Galerie}</SPAN><br />
            oder<br />
            <SPAN style="font-weight:bold;">{SlimBox2|Meine Galerie,Anzahl Vorschaubilder pro Zeile}</SPAN><br />
            Übersteuert die Anzahl Vorschaubild (pro Zeile) Einstellung unten, zB. {SlimBox2|Meine Galerie,4}<br />
            oder<br />
            <SPAN style="font-weight:bold;">{SlimBox2|Ein Vorschau Bild mit der moziloCMS Syntax,Das Bild mit der moziloCMS Syntax}</SPAN><br />
            z.B. {SlimBox2|[bild|mozilo.jpg],[bild|mozilo.jpg]} <br />
            oder<br />
            <SPAN style="font-weight:bold;">{SlimBox2|DemoGalerie,Einzelvorschau}</SPAN><br />
            Nur das erste Bild das Galerie wird als Vorschau angezeigt, es wird kein Bild-Titel angezeigt!<br />
            oder<br />
            <SPAN style="font-weight:bold;">{SlimBox2|DemoGalerie,Einzelvorschau:Ein Bild in der moziloSyntax}</SPAN><br />
            z.B. {SlimBox2|DemoGalerie,Einzelvorschau:[bild|mozilo.jpg]}<br />
            Das angegebene Bild aus den Dateien wird als Vorschaubild angezeigt. Es kann in der mozilo Bild-Syntax ein Untertitel angegeben werden <br />
            z.B. {SlimBox2|DemoGalerie,Einzelvorschau:[bild=Eigener Untertitel|mozilo.jpg]} <br />
            oder<br />
            <SPAN style="font-weight:bold;">{SlimBox2|DemoGalerie,Einzelvorschau:Beliebiger Text als Link}</SPAN><br />
            Textlink als Vorschau für Galerie z.B.<br />
            {SlimBox2|DemoGalerie,Einzelvorschau:Ich bin ein beliebiger Text als Link}<br /> 
            <br />
            <br />
            Bei Target <SPAN style="font-weight:bold;">blank</SPAN>:<br />
            Optional ein Link Text am Ende mit <SPAN style="color:red;">Komma</SPAN> getrennt<br />
            z.B. <SPAN style="font-weight:bold;">{SlimBox2|Meine Galerie , Link Text}</SPAN> <br />
            <SPAN style="font-weight:bold;">{SlimBox2}</SPAN> in der <SPAN style="color:red;">gallerytemplate.html</SPAN> des Layouts. <br /><br />
            In der index.php des Plugins können noch weitere (JavaScript)Parameter eingestelt werden. <br />
            Website der SlimBox http://code.google.com/p/slimbox/.<br /><br />',
            // Name des Autors
            "stefanbe + hausl78",
            // Download-URL
            "http://www.mozilo.de/forum/index.php?action=media",
            array('{SlimBox2|}' => 'Meine Galerie oder Bild,Link Text Galerie blank oder ein Vorschau Bild mit der moziloCMS Syntax,Das Bild mit der moziloCMS Syntax')
            );

        if(isset($info[$language])) {
            return $info[$language];
        } else {
            return $info['deDE'];
        }
    }
}

?>