<?php if(!defined('IS_CMS')) die();
/*
    -------------------------------------------------------------------
    moziloCMS-Plugin, das die Erstellung eigener HTML-Anker ermöglicht.
    -------------------------------------------------------------------
    
    Details und Dokumentation: http://software.azett.com
    
*/

class anker extends Plugin {

    function getContent($value) {
        // Text innerhalb des Ankers darstellen
        if ($this->settings->get("textposition") == "inner") {
            return "<a href=\"#".$this->calculateId($value)."\" id=\"".$this->calculateId($value)."\">".$value."</a>";
        }
        // Text nach leerem Anker darstellen
        else {
            return "<a id=\"".$this->calculateId($value)."\"></a>".$value;
        }
    } // function getContent
    
    
    
    function getConfig() {
        // keine Config nötig
        $config = array();
        $config['textposition'] = array(
            "type" => "radio",                          // Pflicht:  Eingabetyp
            "description" => "Art der Ausgabe:",           // Pflicht:  Beschreibung
            // Pflicht: Beschreibung der einzelnen Auswahlmöglichkeiten
            "descriptions" => array(
                "inner" => "Innerhalb des Ankers: &lt;a id=\"<b>ID</b>\"&gt;<b>TEXT</b>&lt;/a&gt;",       // angezeigt wird "Blau", in die plugin.conf gespeichert wird "blau"
                "outer" => "Nach dem leeren Anker: &lt;a id=\"<b>ID</b>\"&gt;&lt;/a&gt;<b>TEXT</b>"
                )
        );                
        return $config;
    } // function getConfig    
    
    
    function getInfo() {
        $info = array(
            // Plugin-Name + Version
            "<b>Individuelle Anker</b> 2.0",
            // moziloCMS-Version
            "2.0",
            // Kurzbeschreibung nur <span> und <br /> sind erlaubt
            "Erstellt individuelle und valide HTML-Anker.",
            // Name des Autors
            "Original von Arvid Zimmermann, portiert auf mozilo 2.0 von maiemi",
            // Download-URL
            "http://www.mozilo.de/forum/index.php?action=media;sa=album;in=6",
            // Platzhalter für die Selectbox in der Editieransicht 
            // - ist das Array leer, erscheint das Plugin nicht in der Selectbox
            array(
                '{anker|}' => 'Anker'
            )
        );
        return $info;
        
    } // function getInfo
    
    // Anker-ID so erstellen, daß sie HTML-valide ist 
    // - muß mit Buchstaben beginnen
    // - erlaubte Zeichen: a-z A-Z 0-9 - _ : .
    // - nicht erlaubte Zeichen werden durch Unterstrich ersetzt
    function calculateId($content) {
        $regex = "a-zA-Z0-9\-\_\:\.";
    //    return "a_".preg_replace("/[^".$regex."\.]/i", "_", html_entity_decode($content));
	return "a_".preg_replace("/[^".$regex."\.]/i", "_",
html_entity_decode($content, ENT_COMPAT | ENT_HTML401, 'utf-8'));
    }

} // class anker

?>
