<?php
/***************************************************************
* 
* Mehrsprachigkeit für moziloCMS 
* 
***************************************************************/
class i18n extends Plugin {

    // Übersetzungen für Kategorie- und Inhaltsseiten-Namen
    var $translations_as_properties = null;
    
    // Verfügbare Sprachen
    var $available_languages = null;
    var $i18n = null;
	 /***************************************************************
    * 
	*  in Mozilo 2.1 beim Aufrufen aus SearchClass soll  initialisiert sein
    * 
    ***************************************************************/
	public function __construct()
	{
		global $i18n, $SEARCH_REQUEST, $HIGHLIGHT_REQUEST;
		
		parent::__construct();
				
		 // Verfügbare Übersetzungen initialisieren
        $this->initializeTranslations();
				
		$i18n = $this->available_languages[0];	
		
		if (isset($_GET["i18n"])){
			if (strlen($_GET["i18n"]) >= 2)	{				
				$i18n = strtolower(substr($_GET["i18n"], 0, 2));				
				if (!in_array($i18n, $this->available_languages)){
					$i18n = $this->available_languages[0];
				}						
			}
		}
		else{			
			if (isset($_SESSION["cmslanguage"])){
				if ($SEARCH_REQUEST != "" or $HIGHLIGHT_REQUEST != ""){
					$i18n = substr($_SESSION["cmslanguage"],0,2);
				}
			}
				
		}		
		
		$_SESSION["cmslanguage"] = $i18n . strtoupper($i18n);
		
		$this->translations_as_properties = $this->getTranslationsAsProperties($i18n);	

	}
	
	
    /***************************************************************
    * 
    * Gibt den HTML-Code zurück, mit dem die Plugin-Variable ersetzt 
    * wird. Der String-Parameter $value ist Pflicht, kann aber leer 
    * sein.
    * 
    ***************************************************************/
    function getContent($value) {
		global $i18n;
		global $HIGHLIGHT_REQUEST, $SEARCH_REQUEST;
		global $CatPage;
		global $language;

        // Plugin-eigene Platzhalter ersetzen
		if ($value == "plugin_first") {
			require_once(BASE_DIR_CMS."Language.php");
			$language = new Language(BASE_DIR_CMS.LANGUAGE_DIR_NAME."/language_".$_SESSION["cmslanguage"].".txt");

			if ($SEARCH_REQUEST != ""){
				$this->setNamesOnSearch();
			}
		}
        else if ($value == "") {
			return $this->getLanguageSwitch();
        }				
        else if ($value == "mainmenu") {
            return $this->getI18nMainMenu();
        }
        else if ($value == "detailmenu") {
            global $CMS_CONF;			
            // Detailmenue (nicht zeigen, wenn Submenues aktiviert sind)
            if ($CMS_CONF->get("usesubmenu") == 0) {
                return $this->getI18nDetailMenu(CAT_REQUEST);
            }
        }
        else if ($value == "sitemap"){
            return $this->getI18nSiteMap(); 
        }
		else if ($value == "sitemaplink"){			
            return $this->geti18nSitemapLink(); 
        }
        else if ($value == "title") {
            return $this->getI18nWebsiteTitle();
        }
		  else if ($value == "locator") {
            return $this->getI18nWebsiteTitleEx();
        }
        else if ($value == "currentlang") {
            //return $_SESSION["i18n_lang"];
			return $i18n;
        }
		else if($value == "description"){
			return  $this->getTranslationForCat("description");	
		}
		else if($value == "keywords"){
			return  $this->getTranslationForCat("keywords");				
		}
        // Parameter vom Content trennen
        $content_lang = substr($value, 0, strpos($value, "|"));
        $content = substr($value, strpos($value, "|")+1, strlen($value)-strpos($value, "|"));
        
        // Sprachwechsel-Links (beginnen mit "switch_")
        if (strpos($content_lang, "switch_") === 0) {
            $switchToLang = substr($content_lang, 7);
            $url = $_SERVER['REQUEST_URI'];
            if (count($_GET) < 1) {
                return '<a href="'.$url.'?i18n='.$switchToLang.'" class="i18n i18n_switch_'.$switchToLang.'">'.$content.'</a>';
            }
            else {
                return '<a href="'.$url.'&amp;i18n='.$switchToLang.'" class="i18n i18n_switch_'.$switchToLang.'">'.$content.'</a>';
            }
        }

        // Sprache des aktuellen Inhalts in der Session gesetzt? Dann anzeigen!
        if ($content_lang == $i18n) {
				//ist vielleicht eine Seite?
				if (strpos($content,"%3A") !== FALSE){
					 list($cat,$page) = explode("%3A", $content);
					if($CatPage->exists_CatPage($cat,$page)) {
						$content = $CatPage->get_PageContent($cat,$page,USE_CMS_SYNTAX,true);
						return $content;
					}
				}
                return   $content;
        }
        // sonst gegen die Default-Sprache prüfen!
        else {
            // Sprache des aktuellen Inhalts ist die Default-Sprache? Dann anzeigen!
            // if ($content_lang == $this->available_languages[0]) {
                // return $content;
            // }
        }
    } // function getContent
    
	function setNamesOnSearch() {
        global $CMS_CONF;
        global $CatPage;
      		
        $include_pages = array(EXT_PAGE);
        if($CMS_CONF->get("showhiddenpagesinsitemap") == "true") {
            $include_pages = array(EXT_PAGE,EXT_HIDDEN);
        }
      
        $categoriesarray = $CatPage->get_CatArray(false, false, $include_pages);
	
        foreach ($categoriesarray as $currentcategory) {
			
            $pagesarray = $CatPage->get_PageArray($currentcategory,$include_pages,true);
			
            foreach ($pagesarray as $currentpage) {
               
			   $page_translated = $this->getTranslationForPage(urldecode($currentcategory), urldecode($currentpage));
			   $CatPage->change_Name($currentcategory, $currentpage, $page_translated);
            }
			
			$cat_translated = $this->getTranslationForCat(urldecode($currentcategory));	
			$CatPage->change_Name($currentcategory, false, $cat_translated);
        }
       
    }
	
	function geti18nSitemapLink(){
		global $CMS_CONF;
		global $URL_BASE;
		global $language;
		
		$url =  $URL_BASE."index.php?action=sitemap";
		$url = $this->geti18nInUrl($url);
			
		if ($CMS_CONF->get("usesubmenu") > 0)
			$cssprefix = "submenu";
		else
			$cssprefix = "detailmenu";
			
		return  "<a href=\"". $url . "\" class=\"".$cssprefix."active\">".$language->getLanguageValue("message_sitemap_0")."</a>";
			
			
	}
	
    /***************************************************************
    * 
    * Schreibt die aktuelle angeforderte Sprache in die Session.
    * 
    ***************************************************************/
    function initializeTranslations() {
		global $CMS_CONF;
		global $i18n;		
        if (!isset($this->available_languages)){
            $this->available_languages = explode(",", $this->settings->get("languages"));
            // Leerzeichen trimmen
            for ($i = 0; $i < count($this->available_languages); $i++) {
                $this->available_languages[$i] = trim($this->available_languages[$i]);
            }
			/*
            // angeforderte Sprache vorhanden? Dann setzen
            if ( in_array($i18n, $this->available_languages)) {
                $_SESSION["cmslanguage"] = $i18n . strtoupper($i18n);
            }
            // sonst Standardsprache setzen, wenn Session noch nicht gesetzt
            elseif (!isset($_SESSION["cmslanguage"])) {
                $_SESSION["cmslanguage"] = $this->available_languages[0]. strtoupper($this->available_languages[0]);
            }
			*/
        }
    }
    
    
    /***************************************************************
    * 
    * Gibt die Konfigurationsoptionen als Array zurück.
    * Ist keine Konfiguration nötig, ist dieses Array leer.
    * 
    ***************************************************************/
    function getConfig() {       
        global $ADMIN_CONF;
		
		if(IS_ADMIN and $this->settings->get("plugin_first") !== "true") {
			$this->settings->set("plugin_first","true");	
        }
		
        $adminlanguage = $ADMIN_CONF->get("language");
		
				
        // Aktuell vorhandene Inhaltsseiten einlesen
        if ($this->settings->get("initialize") == "true") {
            $this->initializeContent();
        }
		
        // Verfügbare Übersetzungen initialisieren
        //$this->initializeTranslations(); //es wird schon in Constructor erledigt

// DEUTSCH
        $config['deDE'] = array();
        $config['deDE']['languages']  = array(
            "type" => "text",
            "description" => "Verfügbare Sprachen (kommasepariert; erste ist der Standard)",
            "regex" => "/^.+$/", // wenigstens ein Zeichen!
            "regex_error" => "Keine Sprachen angegeben."
        );
        // Texteingabefeld für jede konfigurierte Sprache
        foreach ($this->available_languages as $current_lang) {
            $config['deDE']['lang_'.$current_lang] = array(
                "type" => "textarea",
                "rows" => "10",
                "description" => "Übersetzte Kategorie- und Seitennamen (".$current_lang.")"
            );
        }
        $config['deDE']['initialize'] = array(
            "type" => "checkbox",
            "description" => "Kategorien und Inhaltsseiten neu einlesen <br />(vorhandene&nbsp;Werte&nbsp;bleiben&nbsp;erhalten) nur ein mal beim Abrufen der Einstellungen."
        );
		 // $config['deDE']['hiddenpages'] = array(
            // "type" => "checkbox",
            // "description" => "Übersetzungen in versteckten Seiten (z.B. DefaultSpracheName-en für englisch)"
        // );
// ENGLISCH
        $config['enEN'] = array();
        $config['enEN']['languages']  = array(
            "type" => "text",
            "description" => "Available languages (comma-separated; first one is the default)",
            "regex" => "/^.+$/", // wenigstens ein Zeichen!
            "regex_error" => "No langugages specified."
        );
        // Texteingabefeld für jede konfigurierte Sprache
        foreach ($this->available_languages as $current_lang) {
            $config['enEN']['lang_'.$current_lang] = array(
                "type" => "textarea",
                "rows" => "10",
                "description" => "Translated names of categories and content pages (".$current_lang.")"
            );
        }
        $config['enEN']['initialize'] = array(
            "type" => "checkbox",
            "description" => "Initialize categories and content pages<br />(already&nbsp;set&nbsp;values&nbsp;will&nbsp;not&nbsp;be&nbsp;changed) only once on calling this dialog again"
        );
        // $config['enEN']['hiddenpages'] = array(
            // "type" => "checkbox",
            // "description" => "Translations in hidden pages (z.B. DefaultLanguageName-en for english)"
        // );
        //  Optionen-Array der aktuell im Admin verwendeten Sprache zurückgeben
        if(isset($config[$adminlanguage])) {
            return $config[$adminlanguage];
        }
        // Stellt das Plugin diese Sprache nicht zur Verfügung, werden die englischen Optionen zurückgegeben.
        else {
            return $config['enEN'];
        }
    } // function getConfig    
    
    
    /***************************************************************
    * 
    * Gibt die Plugin-Infos als Array zurück - in dieser 
    * Reihenfolge:
    *   - Name und Version des Plugins
    *   - für moziloCMS-Version
    *   - Kurzbeschreibung
    *   - Name des Autors
    *   - Download-URL
    *   - Platzhalter für die Selectbox
    * 
    ***************************************************************/
    function getInfo() {
        
        global $ADMIN_CONF;
        
        $language = $ADMIN_CONF->get("language");
		$pluginname ="<b>i18n</b>  Mehrsprachigkeit / Multilingualism Version 0.89";
        $cmsversion = "2.0 / 2.1 publius";
        $author = "A. Zimmermann - erweitert von A. Fleischmann";
        $website = array("http://mozilo.info","Demo online");
             
		// DEUTSCH
        $pluginvariables_de = array();
        foreach ($this->available_languages as $current_lang) {
            $pluginvariables_de['{i18n|'.$current_lang.'|}'] = 'Mehrsprachiger Inhalt: '.$current_lang;
        }
        $info['deDE'] = array(
            // Plugin-Name + Version
            $pluginname,
            // moziloCMS-Version
            $cmsversion,
            // Kurzbeschreibung nur <span> und <br /> sind erlaubt
            "Mehrsprachigkeit für moziloCMS-Inhalte<br />"
            ."<br />"
            .$this->boldspan("Nutzung")."<br />"
			.$this->codespan("{i18n}")." - Sprachumschalter - sucht Bilder in i18n/images/de.gif , i18n/images/en.gif <br />"
            .$this->codespan("{i18n|de|Text}")." - Text, der nur angezeigt wird, wenn \"de\" die gewählte Sprache ist.<br />"
            ."<br />"
            .$this->codespan("{i18n|switch_de|Linktext}")." - Link (mit beliebigem Linktext) zum Wechseln der Sprache. Hier: Wechsel zu \"de\".<br />"
            .$this->codespan("{i18n|switch_en|Linktext}")." - Anderes Beispiel: Wechsel zu \"en\".<br />"
            ."<br />"
            .$this->codespan("{i18n|mainmenu}")." - Hauptmenü mit den übersetzten Namen von Kategorien (und, bei aktiviertem Submenü, auch Inhaltsseiten).<br />"
            .$this->codespan("{i18n|detailmenu}")." - Detailmenü mit den übersetzten Namen der Inhaltsseiten.<br />"
            .$this->codespan("{i18n|title}")." - Website-Titel .<br />"
			.$this->codespan("{i18n|locator}")." - Website-Titel mit den übersetzten Namen von Kategorien und Inhaltsseiten (wie in der Einstellungen).<br />"
            .$this->codespan("{i18n|sitemap}")." - Sitemap mit den übersetzten Namen von Kategorien und Inhaltsseiten.<br />"
			.$this->codespan("{i18n|keywords}")." - Webseite keywords.<br />"
			.$this->codespan("{i18n|description}")." - Webseite - Beschreibung.<br />"
            .$this->codespan("{i18n|currentlang}")." - Aktuell gesetzte Sprache, z.B.\"de\".",
            // Name des Autors
            $author,
            // Download-URL
            $website,
            // Platzhalter für die Selectbox in der Editieransicht 
            // - ist das Array leer, erscheint das Plugin nicht in der Selectbox
            $pluginvariables_de
        );

		// ENGLISCH
        $pluginvariables_en = array();
        foreach ($this->available_languages as $current_lang) {
            $pluginvariables_en['{i18n|'.$current_lang.'|}'] = 'Multi-language content: '.$current_lang;
        }
        $info['enEN'] = array(
            // Plugin-Name + Version
            $pluginname,
            // moziloCMS-Version
            $cmsversion,
            // Kurzbeschreibung nur <span> und <br /> sind erlaubt
            "Multi-language content for moziloCMS<br />"
            ."<br />"
            .$this->boldspan("Usage")."<br />"
			.$this->codespan("{i18n}")." - Language switch - use images from i18n/images/de.gif , i18n/images/de.gif <br />"
            .$this->codespan("{i18n|en|Text}")." - Text which is only shown if \"en\" is selected language.<br />"
            ."<br />"
            .$this->codespan("{i18n|switch_en|link text}")." - Link (with any link text) to switch the language. Here: Switch to \"en\".<br />"
            .$this->codespan("{i18n|switch_de|link text}")." - Another example: Switch to \"de\".<br />"
            ."<br />"
            .$this->codespan("{i18n|mainmenu}")." - Main menu with translated names of categories (and, with activated submenu, content pages).<br />"
            .$this->codespan("{i18n|detailmenu}")." - Detail menu with translated names of the content pages.<br />"
            .$this->codespan("{i18n|title}")." - Website title.<br />"
			.$this->codespan("{i18n|locator}")." - Website title with translated names of categories and content pages (as in settings seted).<br />"
            .$this->codespan("{i18n|sitemap}")." - Sitemap with translated names of categories and content pages.<br />"
			.$this->codespan("{i18n|keywords}")." - Website - keywords.<br />"
			.$this->codespan("{i18n|description}")." - Website - description.<br />"
            .$this->codespan("{i18n|currentlang}")." - Currently set language, i.e. \"en\".",
            // Name des Autors
            $author,
            // Download-URL
            $website,
            // Platzhalter für die Selectbox in der Editieransicht 
            // - ist das Array leer, erscheint das Plugin nicht in der Selectbox
            $pluginvariables_en
        );
        
        // Info-Array der aktuell im Admin verwendeten Sprache zurückgeben
        if(isset($info[$language])) {
            return $info[$language];
        }
        // Stellt das Plugin diese Sprache nicht zur Verfügung, werden die englischen Optionen zurückgegeben.
        else {
            return $info['enEN'];
        }
    } // function getInfo
    

    /***************************************************************
    * 
    * Aufbau des Hauptmenues, Rueckgabe als String
    * 
    * Diese Funktion wurde aus dem CMS-Standard 1.12.beta3 kopiert 
    * und angepaßt.
    * 
    ***************************************************************/
    function getI18nMainMenu($anchor = "") {
		global $CMS_CONF;
		global $CatPage;
	
				
		$mainmenu = "<ul class=\"mainmenu\">\n";

		// Jedes Element des Arrays ans Menue anhaengen
		foreach($CatPage->get_CatArray() as $cat) {
			
			 // i18n: Standard-Namen durch Übersetzung ersetzen, wenn vorhanden
			$textCat =  $CatPage->get_HrefText($cat,false);
			
            $translated = $this->getTranslationForCat(urldecode($textCat));			
            // /i18n
			$mainmenu .= '<li class="mainmenu">'
				.$this->create_AutoLinkTag($cat,false,"menu", $translated, $anchor) ;
			
			if($CatPage->is_Activ($cat,false)
					and $CMS_CONF->get("usesubmenu") > 0) {
				$mainmenu .= $this->getI18nDetailMenu($cat);
			} elseif(!$CatPage->is_Activ($cat,false)
					and $CMS_CONF->get("usesubmenu") == 2) {
				$mainmenu .= $this->getI18nDetailMenu($cat);
			}
			$mainmenu .= "</li>\n";

		}
		// Rueckgabe des Menues
		
		return $mainmenu . "</ul>\n";
	}
	
	# erzeugt einen default link wie im menue mit default tooltips und setzt in automatisch activ
    # $css = css class, wenn cat oder page activ wird an die class ein "active" angehängt
	#marcaurel - translation
    function create_AutoLinkTag($cat,$page,$css,$urlTextTranslated = "", $anchor= "") {
        global $language;
		global $CatPage;	

        if($page !== false) {
            if($CatPage->get_Type($cat,$page) == EXT_LINK) {
                $title = $language->getLanguageHtml("tooltip_link_extern_1", $CatPage->get_HrefText($cat,$page));
                $target = $CatPage->get_HrefTarget($cat,$page);
            } else {
                $title = $language->getLanguageHtml("tooltip_link_page_2", $CatPage->get_HrefText($cat,$page),$CatPage->get_HrefText($cat,false));
                $target = false;
            }
            return $this->create_LinkTag(
                    $CatPage->get_Href($cat,$page),
                    $CatPage->get_HrefText($cat,$page),
                    $css.$CatPage->get_CssActiv($cat,$page),
                    $title,$target,false,$urlTextTranslated, $anchor);
        }
        if($CatPage->get_Type($cat,false) == EXT_LINK) {
            $title = $language->getLanguageHtml("tooltip_link_extern_1", $CatPage->get_HrefText($cat,false));
            $target = $CatPage->get_HrefTarget($cat,false);
        } else {
            $title = $language->getLanguageHtml("tooltip_link_category_1", $CatPage->get_HrefText($cat,false));
            $target = false;
        }
        return $this->create_LinkTag(
                $CatPage->get_Href($cat,false),
                $CatPage->get_HrefText($cat,false),
                $css.$CatPage->get_CssActiv($cat,false),
                $title,$target,false,$urlTextTranslated, $anchor);
    }
	
	function create_ActionLinkTag($action,$cssprefix = "") {
        if($action != "search" and $action != "sitemap") return NULL;
        global $specialchars, $language, $SEARCH_REQUEST;

        $url = $this->{"ActionLink".$action};
        $add = "?";
        if(strpos($url,"?") > 1)
            $add = "&amp;";
        $requesturl = NULL;
        $lang = $language->getLanguageHtml("message_sitemap_0");
        if($action == "search") {
            if(strlen($SEARCH_REQUEST) > 0)
                $requesturl = $add."search=".$specialchars->replaceSpecialChars($SEARCH_REQUEST, false);
            $lang = $language->getLanguageHtml("message_searchresult_1", $specialchars->rebuildSpecialChars($SEARCH_REQUEST,false,true));
        }
        if(DRAFT) {
            if($requesturl === NULL)
                $requesturl = $add."draft=true";
            else
                $requesturl .= "&amp;draft=true";
        }
        return $this->create_LinkTag($url.$requesturl
                ,$lang
                ,$cssprefix
                ,false);
    }

	
	# Erzeugt einen HTML Link
    # $url = TEXT
    # $urltext = TEXT
    # $css = false oder TEXT
    # $titel = false oder TEXT
    # $target = false oder _blank, _self
    # $id = false oder TEXT
	#marcaurel - translation
    function create_LinkTag($url,$urltext,$css = false,$titel = false,$target = false,$id = false, $urlTextTranslated = "", $anchor= "") {
        global $syntax;
        $linkcss = NULL;
		
		if ($urlTextTranslated != "")
		{
			$urltext = $urlTextTranslated;
			
		}
        # ist $css ein TEXT wird ein class atribut erzeugt ansonsten nicht
        if($css !== false)
            $linkcss = ' class="'.$css.'"';
        $linktitel = NULL;
        # ist $titel ein TEXT wird ein titel atribut erzeugt ansonsten nicht
        if($titel !== false)
            $linktitel = $syntax->getTitleAttribute($titel);
        $linktarget = NULL;
        if($target !== false and $target == "_blank")
            $linktarget = ' target="'.$target.'"';
        $linkid = NULL;
        if($id !== false)
            $linkid = ' id="'.$id.'"';
		
		$url = $this->geti18nInUrl($url) . $anchor;		
		return '<a href="'.$url.'"'.$linkcss.$linktitel.$linktarget.$linkid.'>'.$urltext.'</a>';
    }
    
	// ------------------------------------------------------------------------------
	// Aufbau des Detailmenues, Rueckgabe als String
	// ------------------------------------------------------------------------------
	function getI18nDetailMenu($cat) {
		global $language;
		global $specialchars;
		global $CMS_CONF;
		global $CatPage;
		
	
		if ($CMS_CONF->get("usesubmenu") > 0)
			$cssprefix = "submenu";
		else
			$cssprefix = "detailmenu";

		$detailmenu = "<ul class=\"detailmenu\">\n";
		// Sitemap
		if ((ACTION_REQUEST == "sitemap") and ($CMS_CONF->get("usesubmenu") == 0))
			$detailmenu .= '<li class="detailmenu">'.$CatPage->create_ActionLinkTag("sitemap",$cssprefix."active").'</li>\n';
		// Suchergebnis
		elseif ((ACTION_REQUEST == "search") and ($CMS_CONF->get("usesubmenu") == 0))
			$detailmenu .= '<li class="detailmenu">'.$CatPage->create_ActionLinkTag("search",$cssprefix."active").'</li>\n';
		// "ganz normales" Detailmenue einer Kategorie
		else {
			// Content-Verzeichnis der aktuellen Kategorie einlesen
			$pagearray = $CatPage->get_PageArray($cat);
			# wenn keine Inhaltseiten lehr zurück
			if(count($pagearray) == 0)
				return NULL;
			// Jedes Element des Arrays ans Menue anhaengen
			foreach ($pagearray as $page) {
				$textPage =  $CatPage->get_HrefText($cat,$page);
				$translated = $this->getTranslationForPage($cat,$textPage);	
				
				$detailmenu .= '<li class="detailmenu">'							
					.$this->create_AutoLinkTag($cat,$page,$cssprefix,$translated)
					."</li>\n";
			}
		}
		// Rueckgabe des Menues
		return $detailmenu . "</ul>\n";
	}
	
    
	function getI18nSiteMap() {
        //global $language;
        global $CMS_CONF;
        global $CatPage;
      		
        $include_pages = array(EXT_PAGE);
        if($CMS_CONF->get("showhiddenpagesinsitemap") == "true") {
            $include_pages = array(EXT_PAGE,EXT_HIDDEN);
        }

        //$sitemap = "<h1>".$language->getLanguageValue("message_sitemap_0")."</h1>";
        $sitemap = "<div class=\"sitemap\">";
        // Kategorien-Verzeichnis einlesen
        $categoriesarray = $CatPage->get_CatArray(false, false, $include_pages);
		
        // Jedes Element des Arrays an die Sitemap anhaengen
        foreach ($categoriesarray as $currentcategory) {
			
            //$i18n_cat = $this->getTranslation("___".urldecode($currentcategory));
			$i18n_cat = $this->getTranslationForCat(urldecode($currentcategory));
            //$sitemap .= "<h2>".$CatPage->get_HrefText($currentcategory,false)."</h2><ul>";
            $sitemap .= "<h2>".$i18n_cat."</h2><ul>";
            // Inhaltsseiten-Verzeichnis einlesen
            $contentarray = $CatPage->get_PageArray($currentcategory,$include_pages,true);
            // Alle Inhaltsseiten der aktuellen Kategorie auflisten...
            // Jedes Element des Arrays an die Sitemap anhaengen
			
            foreach ($contentarray as $currentcontent) {
                $url = $CatPage->get_Href($currentcategory,$currentcontent);
                $urltext = $CatPage->get_HrefText($currentcategory,$currentcontent);
                //$i18n_page = html_entity_decode($this->getTranslationForPage("___".urldecode($currentcategory), urldecode("___".$urltext.".___"), false));
				$i18n_page = $this->getTranslationForPage(urldecode($currentcategory), urldecode($currentcontent));
                $titel = $i18n_page ; //$language->getLanguageValue2("tooltip_link_page_2", $CatPage->get_HrefText($currentcategory,$currentcontent), $CatPage->get_HrefText($currentcategory,false));
                $sitemap .= "<li>".$this->create_LinkTag($url,$i18n_page,false,$titel,false,false,$i18n_page )."</li>";
            }
            $sitemap .= "</ul>";
        }
        $sitemap .= "</div>";
        // Rueckgabe der Sitemap
        return $sitemap;
    }

	
    
    /***************************************************************
    * 
    * Hilfsfunktion: Textarea-Inhalt als Properties-Objekt zurückgeben
    * 
    ***************************************************************/
    function getTranslationsAsProperties($lang, $print = false) {
       
        $translations_as_array = explode("<br />", $this->settings->get("lang_".$lang));
        // Übersetzungen einlesen
        $translations_as_properties = new SimpleProperties();
        foreach ($translations_as_array as $currentline) {
            // Zeile am ersten "=" aufsplitten
            $equalpos = strpos($currentline, "=");
            if ($equalpos > 0) {
                $currentvalue = trim(substr($currentline, $equalpos+1, strlen($currentline)-$equalpos));
                $currentkey = trim(substr($currentline, 0, $equalpos));
                $translations_as_properties->set($currentkey, $currentvalue);
				if ($print){
					echo "<h5> key:" . $currentkey . " val:".$currentvalue;
				}
            }
        }
		
        return $translations_as_properties;
    }

    
    /***************************************************************
    * 
    * Hilfsfunktion: Properties-Objekt in die Plugin-Settings speichern
    * 
    ***************************************************************/
    function setTranslationsFromProperties($translations, $lang) {
 
        $translations_as_array = $translations->toArray();
        $translations = "";
        foreach ($translations_as_array as $currentkey => $currentvalue) {
            if ($currentkey != "readonly") {
                $translations = $translations . $currentkey . " = " . $currentvalue . "<br />";
            }
        }
        $this->settings->set("lang_".$lang, $translations);
    }

   
		
    /***************************************************************
    * 
    * Liest Kategorien und Inhaltsseiten in die Plugin-Config ein.
    * Bereits vorhandene Elemente werden dabei nicht geändert.
    * 
    ***************************************************************/
    function initializeContent() {
        global $CONTENT_DIR_REL;
        global $specialchars;
        global $CatPage;
		
        foreach ($this->available_languages as $current_lang) {
            $translations_as_properties = $this->getTranslationsAsProperties($current_lang);
			
            //$categoriesarray = getDirAsArray($CONTENT_DIR_REL, false, false);
			$categoriesarray = $CatPage->get_CatArray();
            foreach($categoriesarray as $cat) {
                // Kategorie
				$textCat =  $specialchars->getHtmlEntityDecode($CatPage->get_HrefText($cat,false));
				
                if (!$translations_as_properties->keyExists($textCat)) {
                        $translations_as_properties->set($textCat, "");
                }
				
                // zugehörige Inhaltsseiten            
				$pagearray = $CatPage->get_PageArray($cat);
                if ($pagearray != 0) {
                    foreach ($pagearray as $page) {
                        $keyToCheck = $textCat . ":" . $specialchars->getHtmlEntityDecode($CatPage->get_HrefText($cat,$page));
						if (!$translations_as_properties->keyExists($keyToCheck)) {
                            $translations_as_properties->set($keyToCheck, "");
                        }
                    }
                }
                $this->setTranslationsFromProperties($translations_as_properties, $current_lang);
            }
        }
		// dann wieder auf false
        $this->settings->set("initialize", "false");
    }
	

    /***************************************************************
    * 
    * Rueckgabe des Website-Titels
    * 
    * Diese Funktion wurde aus dem CMS-Standard 1.12.beta3 kopiert 
    * und angepaßt.
    * 
    ***************************************************************/
	 function getI18nWebsiteTitle() {		
		global $specialchars, $CMS_CONF;
        $websitetitle = $specialchars->rebuildSpecialChars($CMS_CONF->get("websitetitle"),false,true);
		$websitetitle = $this->getTranslationForCat($websitetitle);
		return $websitetitle;
	}
    function getI18nWebsiteTitleEx() {		
			
        global $CMS_CONF;
        global $specialchars;
        global $ACTION_REQUEST;      		
		global $CatPage;
		
        $cat = $CatPage->get_HrefText(CAT_REQUEST,false);
        $page = $CatPage->get_HrefText(CAT_REQUEST,PAGE_REQUEST);
				
		$title = $specialchars->rebuildSpecialChars($CMS_CONF->get("websitetitle"),false,true);
		
        $websitetitle = $this->getTranslationForCat($title);
		$page = $this->getTranslationForPage($cat, $page);
        $cat = $this->getTranslationForCat($cat);
        				
        // Für Suche und Sitemap: Standard-Titel zurückgeben
        if (($ACTION_REQUEST == "sitemap") || ($ACTION_REQUEST == "search")) {
            // TODO: Hier könnte man auch noch Übersetzungen abfragen!
            return getWebsiteTitle();
        }

        $title = $specialchars->rebuildSpecialChars($CMS_CONF->get("titlebarformat"),true,true);
        $sep = $specialchars->rebuildSpecialChars($CMS_CONF->get("titlebarseparator"),true,true);
        $title = preg_replace('/{WEBSITE}/', $websitetitle, $title);
        if ($cat == "") {
            $title = preg_replace('/{CATEGORY}/', "", $title);
        }
        else {
            $title = preg_replace('/{CATEGORY}/', $cat, $title);
        }
        $title = preg_replace('/{PAGE}/', $page, $title);
        $title = preg_replace('/{SEP}/', $sep, $title);
		
		if ($title == $sep){
		$title = "";
		}
        return $title;
		
		
    }

    
    /***************************************************************
    * 
    * Standard-Kategorienamen durch Übersetzung ersetzen, wenn vorhanden
    * 
    ***************************************************************/
     function getTranslationForCat($cat) {
		global $CatPage;

        global $specialchars;
        global $CHARSET;
			
		$i18n_catToCheck = urldecode($cat);
	
        if (($this->translations_as_properties != null) && $this->translations_as_properties->keyExists($i18n_catToCheck) && ($this->translations_as_properties->get($i18n_catToCheck) != "")) {
            $cat =  htmlentities($this->translations_as_properties->get($i18n_catToCheck),ENT_COMPAT,CHARSET);			
			
        } 			
        return urldecode($cat); 

    } 
    /***************************************************************
    * 
    * Standard-Inhaltsseitennamen durch Übersetzung ersetzen, wenn vorhanden
    * 
    ***************************************************************/
    function getTranslationForPage($cat, $page) {
        global $specialchars;
        global $CHARSET;
		
		$i18n_pageToCheck = urldecode($cat) . ":" . urldecode($page);
     
        if (($this->translations_as_properties != null) && $this->translations_as_properties->keyExists($i18n_pageToCheck) && ($this->translations_as_properties->get($i18n_pageToCheck) != "")) {
            $page = htmlentities($this->translations_as_properties->get($i18n_pageToCheck),ENT_COMPAT,CHARSET);
        } 
		
		return urldecode($page);
    }
    
	 /***************************************************************
    * 
    * language switch
    * 
    * Gibt  den "Sprachumschalter" zurück
    * 
    ***************************************************************/
	function getLanguageSwitch() {
		global $LAYOUT_DIR_URL, $i18n;
		
		$links = "";
		$url = $_SERVER['REQUEST_URI'];
		
		for ($i = 0; $i < count($this->available_languages); $i++) {
                $lang = trim($this->available_languages[$i]);
				if ($lang != $i18n){
					$url = $this->replace_urlparam($url, "i18n", $lang);
					$links .= '<a href="'.$url.'">'
						.'<img src="'.URL_BASE.PLUGIN_DIR_NAME.'/i18n/images/'.$lang.'.gif" title="' .$lang. '" alt="' .$lang. '"/></a>';
					}
            }

		$result = $links;
				 
		if ($links == ""){
			$result = $this->buildErrorMsg("Keine Sprachen angegeben.");
		}		
		return $result;		
    }
	
	 /***************************************************************
    * 
    * Hilfsfunktion: es wird eine neues Wert zu einem Parameter eingetragen
    * 
    ***************************************************************/
	function replace_urlparam($url, $key, $value) { 	
		global $counter;		
		
		$url = str_replace('&amp;','&', $url);		
		$pathInfo = parse_url($url);
		$path = $pathInfo['path'];
		$queryString = "";
		if (isset($pathInfo['query'])){
			$queryString = $pathInfo['query'];
		}
		// query string to array
		parse_str($queryString, $queryArray);
		// add the new query parameter into the array
		$queryArray[$key] = $value;
		// build the new query string
		$newQueryStr = http_build_query($queryArray);
		//return path & query
		return $path . "?" . $newQueryStr;				
	}
	
	 /***************************************************************
    * 
    * Hilfsfunktion: gibt den nächsten url separator aus
    * 
    ***************************************************************/
	function getURLParamSeparator($url) {
		$separator = '&amp;';
		if (strpos($url,"?") === false){
			$separator = '?';
		}
		return $separator;	
	}
	
	function geti18nInUrl($url){
		global $i18n;
				
		if ($i18n != $this->available_languages[0]){
			$url .= $this->getURLParamSeparator($url) . "i18n=" . $i18n;
		}
	    return $url;
	}
	
	 function catToName($cat, $rebuildnbsp, $html= false) {
        global $specialchars;
        return $specialchars->rebuildSpecialChars(substr($cat, 3, strlen($cat)), $rebuildnbsp, $html);
    }
	
	function pageToName($page, $rebuildnbsp, $html=false) {
        global $specialchars;
        return $specialchars->rebuildSpecialChars(substr($page, 3, strlen($page) - 7), $rebuildnbsp, $html);
    }

    /***************************************************************
    * 
    * Hilfsfunktion: Gibt Fehlermeldung aus
    * 
    ***************************************************************/
    function buildErrorMsg($msg) {
        return '<span class="deadlink">Fehler im Plugin ankerlink: '.$msg.'</span>';
    }
    
    /***************************************************************
    * 
    * Hilfsfunktion: Text in Code-Span packen
    * 
    ***************************************************************/
    function codespan($content) {
        return "<span style=\"font-family:monospace;margin:3px 3px; background-color:#eee;border:1px dotted #aaa;\">".$content."</span>";
    }

    /***************************************************************
    * 
    * Hilfsfunktion: Text in Bold-Span packen
    * 
    ***************************************************************/
    function boldspan($content) {
        return "<span style=\"font-weight:bold;\">".$content."</span>";
    }
    
    /***************************************************************
    * 
    * Hilfsfunktion: Debug-Ausgabe
    * 
    ***************************************************************/
    function debug($name, $msg) {
        if (true) { // Zum Aktivieren aus "false" "true" machen!
            echo "<h5>". $name .":" . $msg."<br />";
        }
    }
	
} // class i18n

/***************************************************************
* 
* Innere Properties-Klasse
* 
***************************************************************/    
class SimpleProperties
{
    private $data = array();

    public function set($name, $value) {
        $this->data[$name] = $value;
    }

    public function get($name) {
        if (array_key_exists($name, $this->data)) {
            return $this->data[$name];
        }
        return null;
    }

    public function __isset($name) {
        return isset($this->data[$name]);
    }

    public function __unset($name) {
        unset($this->data[$name]);
    }

    public function keyExists($name) {
        return array_key_exists($name, $this->data);
    }
    
    public function toArray() {
        return $this->data;
    }
} // class SimpleProperties

?>